#pragma once

struct graph_snapshot;

#include "graph.h"

struct graph_snapshot {

	struct vds_snapshot {
		size_t num_vertices;
		size_t num_edges;
		long long cost;
	} vds;

	size_t num_changes;
};


class GraphModification {
public:
	virtual void undo(Graph &G) = 0;	
	virtual void translate(Graph &G, list<Vertex *> &sol) {};

	virtual ~GraphModification() {};
};

class GM_Edge_Deletion : public GraphModification {
public:
	vector<Edge *> edges;
	virtual void undo(Graph &G);
	virtual void translate(Graph &G, list<Vertex *> &sol);
};

void restore_snapshot(Graph &G, struct graph_snapshot &s);
struct graph_snapshot create_snapshot(Graph &G);

void add_to_vds(Graph &G, Vertex *a);
void delete_vertex(Graph &G, Vertex *a);
void delete_edge(Graph &G, Edge *e);
void vert_change_deg(Graph &G, Vertex *v, size_t new_deg);
