#include <iostream>
#include <fstream>
#include <vector>
#include <cassert>

#include "graph.h"
#include "branch.h"
#include "optimize.h"

static vector<string> split(const string& str, const string& delim)
{
	vector<string> tokens;
	size_t prev = 0, pos = 0;
	do
	{
		pos = str.find(delim, prev);
		if (pos == string::npos) pos = str.length();
		string token = str.substr(prev, pos-prev);
		if (!token.empty()) tokens.push_back(token);
		prev = pos + delim.length();
	}
	while (pos < str.length() && prev < str.length());
	return tokens;
}


void read_config_from_file(char *file) {
	ifstream fin;
	fin.open(file);

	
	string line;
	while (getline(fin, line)) {
		if (line[0] == '#' || line.size() == 0)
			continue;

		// for some reason "\r\n" is not handled correctly
		if (!line.empty() && line[line.size() - 1] == '\r')
		    line.erase(line.size() - 1);

		vector<string> config = split(line, " ");
	}
}
