#include <cassert>

#include "graph.h"
#include "read_sol.h"

void rs_add_vertex(Vertex *v, list<Vertex *> &sol) {
		assert(!v->in_sol);
		v->in_sol = true;
		sol.push_back(v);
		v->iter_sol = --sol.end();
}

void rs_remove_vertex(Vertex *v, list<Vertex *> &sol) {
		assert(v->in_sol);
		v->in_sol = false;
		sol.erase(v->iter_sol);
}


/* read the VDS G.VDS.S for the transformed graph and translate it into a VDS for
 * the original graph */
void read_sol(Graph &G, list<Vertex *> &sol) {
	for (Vertex *v: G.VDS.S) {
		rs_add_vertex(v, sol);
	}
	
	//check_vc(G);

	for (size_t i = 0; i < G.changes.size(); i++) {
		size_t j = G.changes.size() - i - 1;
		GraphModification *op = G.changes[j];

		op->translate(G, sol);
		//op->undo(G); // it should also work without this (maybe)
		//check_vc(G);
	}
}
